Ecore Getopt
Ecore

This group contains powerful getopt replacement. More...

## Data Structures

union | _Ecore_Getopt_Value
| Union listing the types of parameters that can take Getopt values. More...
struct | _Ecore_Getopt_Desc_Store
| Structure used when action is ECORE_GETOPT_ACTION_STORE. More...
struct | _Ecore_Getopt_Desc_Callback
| Structure used when action is ECORE_GETOPT_ACTION_CALLBACK. More...
struct | _Ecore_Getopt_Desc
| Structure that describe an option of the command line. More...
struct | _Ecore_Getopt
| Structure that contains information on all command line options. More...

## Macros

#define | _ECORE_GETOPT_PREDEF 1
#define | _ECORE_GETOPT_DESC_PREDEF 1
#define | _ECORE_GETOPT_VALUE_PREDEF 1
#define | ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, type, arg_requirement, default_value)
| Definition for macro that helps to fill the Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE(shortname, longname, help, type)
| Definition for macro that fills an option in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_STR(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type string.
#define | ECORE_GETOPT_STORE_BOOL(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type boolean.
#define | ECORE_GETOPT_STORE_SHORT(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type short.
#define | ECORE_GETOPT_STORE_INT(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type int.
#define | ECORE_GETOPT_STORE_LONG(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type long.
#define | ECORE_GETOPT_STORE_USHORT(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type ushort.
#define | ECORE_GETOPT_STORE_UINT(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type uint.
#define | ECORE_GETOPT_STORE_ULONG(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type ulong.
#define | ECORE_GETOPT_STORE_DOUBLE(shortname, longname, help)
| Definition for macro that fill Ecore_Getopt_Desc table with an option of type double.
#define | ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, type)
| Definition for macro that helps to fill the Ecore_Getopt_Desc table with a metavar after the description of the option.
#define | ECORE_GETOPT_STORE_METAVAR_STR(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type string and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_BOOL(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type boolean and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_SHORT(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type short and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_INT(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type int and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_LONG(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type long and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_USHORT(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned short and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_UINT(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned int and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_ULONG(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned long and metavar.
#define | ECORE_GETOPT_STORE_METAVAR_DOUBLE(shortname, longname, help, metavar)
| Definition for filling Ecore_Getopt_Desc table with an option of type double and metavar.
#define | ECORE_GETOPT_STORE_DEF(shortname, longname, help, type, default_value)
| Definition for macro that helps to fill the Ecore_Getopt_Desc table with a default value.
#define | ECORE_GETOPT_STORE_DEF_STR(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type string and default value.
#define | ECORE_GETOPT_STORE_DEF_BOOL(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type boolean and default value.
#define | ECORE_GETOPT_STORE_DEF_SHORT(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type short and default value.
#define | ECORE_GETOPT_STORE_DEF_INT(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type int and default value.
#define | ECORE_GETOPT_STORE_DEF_LONG(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type long and default value.
#define | ECORE_GETOPT_STORE_DEF_USHORT(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned short and default value.
#define | ECORE_GETOPT_STORE_DEF_UINT(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned int and default value.
#define | ECORE_GETOPT_STORE_DEF_ULONG(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type unsigned long and default value.
#define | ECORE_GETOPT_STORE_DEF_DOUBLE(shortname, longname, help, default_value)
| Definition for filling Ecore_Getopt_Desc table with an option of type double and default value.
#define | ECORE_GETOPT_STORE_FULL_STR(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full string type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_BOOL(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full boolean type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_SHORT(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full short type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_INT(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full int type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_LONG(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full long type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_USHORT(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full unsigned short type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_UINT(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full unsigned int type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_ULONG(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full unsigned long type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_FULL_DOUBLE(shortname, longname, help, metavar, arg_requirement, default_value)
| Definition for filling full double type option description in Ecore_Getopt_Desc table.
#define | ECORE_GETOPT_STORE_CONST(shortname, longname, help, value)
| Definition for filling Ecore_Getopt_Desc table with a constant value.
#define | ECORE_GETOPT_STORE_TRUE(shortname, longname, help)
| Definition for filling Ecore_Getopt_Desc table with a true boolean value.
#define | ECORE_GETOPT_STORE_FALSE(shortname, longname, help)
| Definition for filling Ecore_Getopt_Desc table with a false boolean value.
#define | ECORE_GETOPT_CHOICE(shortname, longname, help, choices_array)
| Definition for filling Ecore_Getopt_Desc table with a true boolean value.
#define | ECORE_GETOPT_CHOICE_METAVAR(shortname, longname, help, metavar, choices_array)
| Definition for filling Ecore_Getopt_Desc table with a choice.
#define | ECORE_GETOPT_APPEND(shortname, longname, help, sub_type)
| Definition for filling Ecore_Getopt_Desc table with an append action.
#define | ECORE_GETOPT_APPEND_METAVAR(shortname, longname, help, metavar, type)
| Definition for filling Ecore_Getopt_Desc table with an append action and a metavar.
#define | ECORE_GETOPT_COUNT(shortname, longname, help)
| Definition for filling Ecore_Getopt_Desc table with an count action.
#define | ECORE_GETOPT_CALLBACK_FULL(shortname, longname, help, metavar, callback_func, callback_data, argument_requirement, default_value)
| Definition for filling Ecore_Getopt_Desc table with an callback action and argument requirements.
#define | ECORE_GETOPT_CALLBACK_NOARGS(shortname, longname, help, callback_func, callback_data)
| Definition for filling Ecore_Getopt_Desc table with an callback action and no arguments.
#define | ECORE_GETOPT_CALLBACK_ARGS(shortname, longname, help, metavar, callback_func, callback_data)
| Definition for filling Ecore_Getopt_Desc table with an callback action.
#define | ECORE_GETOPT_HELP(shortname, longname)
| Definition for filling Ecore_Getopt_Desc table with a help action.
#define | ECORE_GETOPT_VERSION(shortname, longname)
| Definition for filling Ecore_Getopt_Desc table with a version action.
#define | ECORE_GETOPT_COPYRIGHT(shortname, longname)
| Definition for filling Ecore_Getopt_Desc table with a copyright action.
#define | ECORE_GETOPT_LICENSE(shortname, longname)
| Definition for filling Ecore_Getopt_Desc table with a license action.
#define | ECORE_GETOPT_BREAK(shortname, longname)
| Definition for filling Ecore_Getopt_Desc table with a break action.
#define | ECORE_GETOPT_BREAK_STR(shortname, longname, help)
| Definition for filling Ecore_Getopt_Desc table with a break action with help message.
#define | ECORE_GETOPT_CATEGORY(name, help)
#define | ECORE_GETOPT_SENTINEL {0, NULL, NULL, NULL, 0, {.dummy = NULL}}
| Definition for filling Ecore_Getopt_Desc table with a sentinel to indicate the end of descriptions.
#define | ECORE_GETOPT_VALUE_STR(val)
| Definition for options that store a single value in a variable of type string.
#define | ECORE_GETOPT_VALUE_BOOL(val)
| Definition for options that store a single value in a variable of type boolean.
#define | ECORE_GETOPT_VALUE_SHORT(val)
| Definition for options that store a single value in a variable of type short.
#define | ECORE_GETOPT_VALUE_INT(val)
| Definition for options that store a single value in a variable of type int.
#define | ECORE_GETOPT_VALUE_LONG(val)
| Definition for options that store a single value in a variable of type long.
#define | ECORE_GETOPT_VALUE_USHORT(val)
| Definition for options that store a single value in a variable of type unsigned short.
#define | ECORE_GETOPT_VALUE_UINT(val)
| Definition for options that store a single value in a variable of type unsigned int.
#define | ECORE_GETOPT_VALUE_ULONG(val)
| Definition for options that store a single value in a variable of type unsigned long.
#define | ECORE_GETOPT_VALUE_DOUBLE(val)
| Definition for options that store a single value in a variable of type double.
#define | ECORE_GETOPT_VALUE_PTR(val)
| Definition for options that store a single value in a variable of type pointer.
#define | ECORE_GETOPT_VALUE_PTR_CAST(val)
| Definition for options that store a single value in a variable of type pointer casted.
#define | ECORE_GETOPT_VALUE_LIST(val)
| Definition for options that store a single value in a variable of type list.
#define | ECORE_GETOPT_VALUE_NONE {.ptrp = NULL}
| Definition for options that store a NULL value.

## Typedefs

typedef struct _Ecore_Getopt_Desc_Store | Ecore_Getopt_Desc_Store
typedef struct _Ecore_Getopt_Desc_Callback | Ecore_Getopt_Desc_Callback
typedef struct _Ecore_Getopt | Ecore_Getopt
typedef struct _Ecore_Getopt_Desc | Ecore_Getopt_Desc
typedef union _Ecore_Getopt_Value | Ecore_Getopt_Value

## Enumerations

enum

Ecore_Getopt_Action {
ECORE_GETOPT_ACTION_STORE ,
ECORE_GETOPT_ACTION_STORE_CONST ,
ECORE_GETOPT_ACTION_STORE_TRUE ,
ECORE_GETOPT_ACTION_STORE_FALSE ,
ECORE_GETOPT_ACTION_CHOICE ,
ECORE_GETOPT_ACTION_APPEND ,
ECORE_GETOPT_ACTION_COUNT ,
ECORE_GETOPT_ACTION_CALLBACK ,
ECORE_GETOPT_ACTION_HELP ,
ECORE_GETOPT_ACTION_VERSION ,
ECORE_GETOPT_ACTION_COPYRIGHT ,
ECORE_GETOPT_ACTION_LICENSE ,
ECORE_GETOPT_ACTION_BREAK ,
ECORE_GETOPT_ACTION_CATEGORY
}

| Enumeration for defining the actions to do when parsing command line parameters. More...
enum | Ecore_Getopt_Type { ECORE_GETOPT_TYPE_STR , ECORE_GETOPT_TYPE_BOOL , ECORE_GETOPT_TYPE_SHORT , ECORE_GETOPT_TYPE_INT , ECORE_GETOPT_TYPE_LONG , ECORE_GETOPT_TYPE_USHORT , ECORE_GETOPT_TYPE_UINT , ECORE_GETOPT_TYPE_ULONG , ECORE_GETOPT_TYPE_DOUBLE }
| Enumeration for defining the type of the values to store when using append action. More...
enum | Ecore_Getopt_Desc_Arg_Requirement { ECORE_GETOPT_DESC_ARG_REQUIREMENT_NO = 0 , ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES = 1 , ECORE_GETOPT_DESC_ARG_REQUIREMENT_OPTIONAL = 3 }
| Enumeration for defining if the command line options require an argument. More...

## Functions

EAPI void | ecore_getopt_help (FILE *fp, const Ecore_Getopt *info)
| Shows nicely formatted help message for the given parser.
EAPI Eina_Bool | ecore_getopt_help_category (FILE *fp, const Ecore_Getopt *info, const char *category)
| Shows help for a single category (along with program usage and description).
EAPI Eina_Bool | ecore_getopt_parser_has_duplicates (const Ecore_Getopt *parser)
| Checks parser for duplicate entries, print them out.
EAPI int | ecore_getopt_parse (const Ecore_Getopt *parser, Ecore_Getopt_Value *values, int argc, char **argv)
| Parses command line parameters.
EAPI int | ecore_getopt_parse_positional (const Ecore_Getopt *parser, Ecore_Getopt_Value *values, int argc, char **argv, int start)
| Parses command line positional parameters.
EAPI Eina_List * | ecore_getopt_list_free (Eina_List *list)
| Utilities to free list and nodes allocated by ECORE_GETOPT_ACTION_APPEND.
EAPI Eina_Bool | ecore_getopt_callback_geometry_parse (const Ecore_Getopt *parser, const Ecore_Getopt_Desc *desc, const char *str, void *data, Ecore_Getopt_Value *storage)
| Helper ecore_getopt callback to parse geometry (x:y:w:h).
EAPI Eina_Bool | ecore_getopt_callback_size_parse (const Ecore_Getopt *parser, const Ecore_Getopt_Desc *desc, const char *str, void *data, Ecore_Getopt_Value *storage)
| Helper ecore_getopt callback to parse geometry size (WxH).

## Detailed Description

This group contains powerful getopt replacement.

This replacement handles both short (-X) or long options (–ABC) options, with various actions supported, like storing one value and already converting to required type, counting number of occurrences, setting true or false values, show help, license, copyright and even support user-defined callbacks.

It is provided a set of C Pre Processor macros so definition is straightforward.

Values will be stored elsewhere indicated by an array of pointers to values, it is given in separate to parser description so you can use multiple values with the same parser.

## Macro Definition Documentation

## ECORE_GETOPT_STORE_FULL

#define ECORE_GETOPT_STORE_FULL | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | type,
|  |  | arg_requirement,
|  |  | default_value )

Value:
{shortname, longname, help, metavar, ECORE_GETOPT_ACTION_STORE, \
{.store = {type, arg_requirement, default_value}}}
ECORE_GETOPT_ACTION_STORE
@ ECORE_GETOPT_ACTION_STORE
Store a value.
Definition Ecore_Getopt.h:65

Definition for macro that helps to fill the Ecore_Getopt_Desc table.

## ECORE_GETOPT_STORE

#define ECORE_GETOPT_STORE | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | type )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, NULL, type, \
ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES, {})
ECORE_GETOPT_STORE_FULL
#define ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, type, arg_requirement, default_value)
Definition for macro that helps to fill the Ecore_Getopt_Desc table.
Definition Ecore_Getopt.h:227
ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES
@ ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES
Argument is required.
Definition Ecore_Getopt.h:105

Definition for macro that fills an option in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  type | The option value type.

## ECORE_GETOPT_STORE_STR

#define ECORE_GETOPT_STORE_STR | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_STR)
ECORE_GETOPT_STORE
#define ECORE_GETOPT_STORE(shortname, longname, help, type)
Definition for macro that fills an option in Ecore_Getopt_Desc table.
Definition Ecore_Getopt.h:239
ECORE_GETOPT_TYPE_STR
@ ECORE_GETOPT_TYPE_STR
Value of type string.
Definition Ecore_Getopt.h:87

Definition for macro that fill Ecore_Getopt_Desc table with an option of type string.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

Examples
  ecore_con_client_example.c, and emotion_test_main.c.

## ECORE_GETOPT_STORE_BOOL

#define ECORE_GETOPT_STORE_BOOL | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_BOOL)
ECORE_GETOPT_TYPE_BOOL
@ ECORE_GETOPT_TYPE_BOOL
Value of type boolean.
Definition Ecore_Getopt.h:88

Definition for macro that fill Ecore_Getopt_Desc table with an option of type boolean.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_SHORT

#define ECORE_GETOPT_STORE_SHORT | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_SHORT)
ECORE_GETOPT_TYPE_SHORT
@ ECORE_GETOPT_TYPE_SHORT
Value of type short.
Definition Ecore_Getopt.h:89

Definition for macro that fill Ecore_Getopt_Desc table with an option of type short.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_INT

#define ECORE_GETOPT_STORE_INT | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_INT)
ECORE_GETOPT_TYPE_INT
@ ECORE_GETOPT_TYPE_INT
Value of type int.
Definition Ecore_Getopt.h:90

Definition for macro that fill Ecore_Getopt_Desc table with an option of type int.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

Examples
  ecore_con_server_example.c, ecore_thread_example.c, and emotion_test_main.c.

## ECORE_GETOPT_STORE_LONG

#define ECORE_GETOPT_STORE_LONG | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_LONG)
ECORE_GETOPT_TYPE_LONG
@ ECORE_GETOPT_TYPE_LONG
Value of type long.
Definition Ecore_Getopt.h:91

Definition for macro that fill Ecore_Getopt_Desc table with an option of type long.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_USHORT

#define ECORE_GETOPT_STORE_USHORT | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_USHORT)
ECORE_GETOPT_TYPE_USHORT
@ ECORE_GETOPT_TYPE_USHORT
Value of type unsigned short.
Definition Ecore_Getopt.h:92

Definition for macro that fill Ecore_Getopt_Desc table with an option of type ushort.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_UINT

#define ECORE_GETOPT_STORE_UINT | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_UINT)
ECORE_GETOPT_TYPE_UINT
@ ECORE_GETOPT_TYPE_UINT
Value of type unsigned int.
Definition Ecore_Getopt.h:93

Definition for macro that fill Ecore_Getopt_Desc table with an option of type uint.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_ULONG

#define ECORE_GETOPT_STORE_ULONG | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_ULONG)
ECORE_GETOPT_TYPE_ULONG
@ ECORE_GETOPT_TYPE_ULONG
Value of type unsigned long.
Definition Ecore_Getopt.h:94

Definition for macro that fill Ecore_Getopt_Desc table with an option of type ulong.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_DOUBLE

#define ECORE_GETOPT_STORE_DOUBLE | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
ECORE_GETOPT_STORE(shortname, longname, help, ECORE_GETOPT_TYPE_DOUBLE)
ECORE_GETOPT_TYPE_DOUBLE
@ ECORE_GETOPT_TYPE_DOUBLE
Value of type double.
Definition Ecore_Getopt.h:95

Definition for macro that fill Ecore_Getopt_Desc table with an option of type double.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_STORE_METAVAR

#define ECORE_GETOPT_STORE_METAVAR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | type )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, type, \
ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES, {})

Definition for macro that helps to fill the Ecore_Getopt_Desc table with a metavar after the description of the option.

## ECORE_GETOPT_STORE_METAVAR_STR

#define ECORE_GETOPT_STORE_METAVAR_STR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_STR)
ECORE_GETOPT_STORE_METAVAR
#define ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, type)
Definition for macro that helps to fill the Ecore_Getopt_Desc table with a metavar after the descript...
Definition Ecore_Getopt.h:336

Definition for filling Ecore_Getopt_Desc table with an option of type string and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

Examples
  ecore_con_client_example.c, and ecore_con_server_example.c.

## ECORE_GETOPT_STORE_METAVAR_BOOL

#define ECORE_GETOPT_STORE_METAVAR_BOOL | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_BOOL)

Definition for filling Ecore_Getopt_Desc table with an option of type boolean and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_SHORT

#define ECORE_GETOPT_STORE_METAVAR_SHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_SHORT)

Definition for filling Ecore_Getopt_Desc table with an option of type short and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_INT

#define ECORE_GETOPT_STORE_METAVAR_INT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_INT)

Definition for filling Ecore_Getopt_Desc table with an option of type int and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

Examples
  ecore_con_client_example.c, and ecore_con_server_example.c.

## ECORE_GETOPT_STORE_METAVAR_LONG

#define ECORE_GETOPT_STORE_METAVAR_LONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_LONG)

Definition for filling Ecore_Getopt_Desc table with an option of type long and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_USHORT

#define ECORE_GETOPT_STORE_METAVAR_USHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_USHORT)

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned short and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_UINT

#define ECORE_GETOPT_STORE_METAVAR_UINT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_UINT)

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned int and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_ULONG

#define ECORE_GETOPT_STORE_METAVAR_ULONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_ULONG)

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned long and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_METAVAR_DOUBLE

#define ECORE_GETOPT_STORE_METAVAR_DOUBLE | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar )

Value:
ECORE_GETOPT_STORE_METAVAR(shortname, longname, help, metavar, ECORE_GETOPT_TYPE_DOUBLE)

Definition for filling Ecore_Getopt_Desc table with an option of type double and metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.

## ECORE_GETOPT_STORE_DEF

#define ECORE_GETOPT_STORE_DEF | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | type,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, NULL, type, \
ECORE_GETOPT_DESC_ARG_REQUIREMENT_OPTIONAL, \
default_value)
ECORE_GETOPT_DESC_ARG_REQUIREMENT_OPTIONAL
@ ECORE_GETOPT_DESC_ARG_REQUIREMENT_OPTIONAL
Argument is optional.
Definition Ecore_Getopt.h:106

Definition for macro that helps to fill the Ecore_Getopt_Desc table with a default value.

## ECORE_GETOPT_STORE_DEF_STR

#define ECORE_GETOPT_STORE_DEF_STR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_STR, \
{.strv = default_value})
ECORE_GETOPT_STORE_DEF
#define ECORE_GETOPT_STORE_DEF(shortname, longname, help, type, default_value)
Definition for macro that helps to fill the Ecore_Getopt_Desc table with a default value.
Definition Ecore_Getopt.h:442

Definition for filling Ecore_Getopt_Desc table with an option of type string and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_BOOL

#define ECORE_GETOPT_STORE_DEF_BOOL | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_BOOL, \
{.boolv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type boolean and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_SHORT

#define ECORE_GETOPT_STORE_DEF_SHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_SHORT, \
{.shortv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type short and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_INT

#define ECORE_GETOPT_STORE_DEF_INT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_INT, \
{.intv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type int and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_LONG

#define ECORE_GETOPT_STORE_DEF_LONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_LONG, \
{.longv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type long and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_USHORT

#define ECORE_GETOPT_STORE_DEF_USHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_USHORT, \
{.ushortv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned short and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_UINT

#define ECORE_GETOPT_STORE_DEF_UINT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_UINT, \
{.uintv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned int and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_ULONG

#define ECORE_GETOPT_STORE_DEF_ULONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_ULONG, \
{.ulongv = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type unsigned long and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_DEF_DOUBLE

#define ECORE_GETOPT_STORE_DEF_DOUBLE | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_DEF(shortname, longname, help, \
ECORE_GETOPT_TYPE_DOUBLE, \
{.doublev = default_value})

Definition for filling Ecore_Getopt_Desc table with an option of type double and default value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_STR

#define ECORE_GETOPT_STORE_FULL_STR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_STR, \
arg_requirement, \
{.strv = default_value})

Definition for filling full string type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_BOOL

#define ECORE_GETOPT_STORE_FULL_BOOL | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_BOOL, \
arg_requirement, \
{.boolv = default_value})

Definition for filling full boolean type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_SHORT

#define ECORE_GETOPT_STORE_FULL_SHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_SHORT, \
arg_requirement, \
{.shortv = default_value})

Definition for filling full short type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_INT

#define ECORE_GETOPT_STORE_FULL_INT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_INT, \
arg_requirement, \
{.intv = default_value})

Definition for filling full int type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_LONG

#define ECORE_GETOPT_STORE_FULL_LONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_LONG, \
arg_requirement, \
{.longv = default_value})

Definition for filling full long type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_USHORT

#define ECORE_GETOPT_STORE_FULL_USHORT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_USHORT, \
arg_requirement, \
{.ushortv = default_value})

Definition for filling full unsigned short type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_UINT

#define ECORE_GETOPT_STORE_FULL_UINT | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_UINT, \
arg_requirement, \
{.uintv = default_value})

Definition for filling full unsigned int type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_ULONG

#define ECORE_GETOPT_STORE_FULL_ULONG | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_ULONG, \
arg_requirement, \
{.ulongv = default_value})

Definition for filling full unsigned long type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_FULL_DOUBLE

#define ECORE_GETOPT_STORE_FULL_DOUBLE | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | arg_requirement,
|  |  | default_value )

Value:
ECORE_GETOPT_STORE_FULL(shortname, longname, help, metavar, \
ECORE_GETOPT_TYPE_DOUBLE, \
arg_requirement, \
{.doublev = default_value})

Definition for filling full double type option description in Ecore_Getopt_Desc table.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  arg_requirement | The option argument requirements.
  default_value | The default value for the parameter of the option.

## ECORE_GETOPT_STORE_CONST

#define ECORE_GETOPT_STORE_CONST | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | value )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_STORE_CONST, \
{.store_const = value}}
ECORE_GETOPT_ACTION_STORE_CONST
@ ECORE_GETOPT_ACTION_STORE_CONST
Store a const.
Definition Ecore_Getopt.h:66

Definition for filling Ecore_Getopt_Desc table with a constant value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  value | The constant value to store.

## ECORE_GETOPT_STORE_TRUE

#define ECORE_GETOPT_STORE_TRUE | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_STORE_TRUE, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_STORE_TRUE
@ ECORE_GETOPT_ACTION_STORE_TRUE
Store TRUE.
Definition Ecore_Getopt.h:67

Definition for filling Ecore_Getopt_Desc table with a true boolean value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, and emotion_test_main.c.

## ECORE_GETOPT_STORE_FALSE

#define ECORE_GETOPT_STORE_FALSE | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_STORE_FALSE, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_STORE_FALSE
@ ECORE_GETOPT_ACTION_STORE_FALSE
Store FALSE.
Definition Ecore_Getopt.h:68

Definition for filling Ecore_Getopt_Desc table with a false boolean value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

Examples
  ecore_con_client_example.c.

## ECORE_GETOPT_CHOICE

#define ECORE_GETOPT_CHOICE | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | choices_array )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_CHOICE, \
{.choices = choices_array}}
ECORE_GETOPT_ACTION_CHOICE
@ ECORE_GETOPT_ACTION_CHOICE
Store a choice between several values.
Definition Ecore_Getopt.h:69

Definition for filling Ecore_Getopt_Desc table with a true boolean value.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  choices_array | An string array of different choices.

Examples
  ecore_con_client_example.c, and ecore_con_server_example.c.

## ECORE_GETOPT_CHOICE_METAVAR

#define ECORE_GETOPT_CHOICE_METAVAR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | choices_array )

Value:
{shortname, longname, help, metavar, ECORE_GETOPT_ACTION_CHOICE, \
{.choices = choices_array}}

Definition for filling Ecore_Getopt_Desc table with a choice.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  choices_array | An string array of different choices.

## ECORE_GETOPT_APPEND

#define ECORE_GETOPT_APPEND | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | sub_type )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_APPEND, \
{.append_type = sub_type}}
ECORE_GETOPT_ACTION_APPEND
@ ECORE_GETOPT_ACTION_APPEND
Allocate and store a new value of type Ecore_Getopt_Type.
Definition Ecore_Getopt.h:70

Definition for filling Ecore_Getopt_Desc table with an append action.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  sub_type | The type of the new value to store.

## ECORE_GETOPT_APPEND_METAVAR

#define ECORE_GETOPT_APPEND_METAVAR | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | type )

Value:
{shortname, longname, help, metavar, ECORE_GETOPT_ACTION_APPEND, \
{.append_type = type}}

Definition for filling Ecore_Getopt_Desc table with an append action and a metavar.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  type | The type of the new value to store.

Examples
  ecore_thread_example.c.

## ECORE_GETOPT_COUNT

#define ECORE_GETOPT_COUNT | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
{shortname, longname, help, NULL, ECORE_GETOPT_ACTION_COUNT, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_COUNT
@ ECORE_GETOPT_ACTION_COUNT
Store a count number.
Definition Ecore_Getopt.h:71

Definition for filling Ecore_Getopt_Desc table with an count action.

This will store the number of time the option has been passed to the command line.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_CALLBACK_FULL

#define ECORE_GETOPT_CALLBACK_FULL | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | callback_func,
|  |  | callback_data,
|  |  | argument_requirement,
|  |  | default_value )

Value:
{shortname, longname, help, metavar, ECORE_GETOPT_ACTION_CALLBACK, \
{.callback = {callback_func, callback_data, \
argument_requirement, default_value}}}
ECORE_GETOPT_ACTION_CALLBACK
@ ECORE_GETOPT_ACTION_CALLBACK
Call a callback.
Definition Ecore_Getopt.h:72

Definition for filling Ecore_Getopt_Desc table with an callback action and argument requirements.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  callback_func | The callback function to call.
  callback_data | The data to pass to the callback.
  argument_requirement | The required arguments to this option.
  default_value | The default values for these arguments.

## ECORE_GETOPT_CALLBACK_NOARGS

#define ECORE_GETOPT_CALLBACK_NOARGS | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | callback_func,
|  |  | callback_data )

Value:
ECORE_GETOPT_CALLBACK_FULL(shortname, longname, help, NULL, \
callback_func, callback_data, \
ECORE_GETOPT_DESC_ARG_REQUIREMENT_NO, \
NULL)
ECORE_GETOPT_CALLBACK_FULL
#define ECORE_GETOPT_CALLBACK_FULL(shortname, longname, help, metavar, callback_func, callback_data, argument_requirement, default_value)
Definition for filling Ecore_Getopt_Desc table with an callback action and argument requirements.
Definition Ecore_Getopt.h:817
ECORE_GETOPT_DESC_ARG_REQUIREMENT_NO
@ ECORE_GETOPT_DESC_ARG_REQUIREMENT_NO
Argument is not required.
Definition Ecore_Getopt.h:104

Definition for filling Ecore_Getopt_Desc table with an callback action and no arguments.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  callback_func | The callback function to call.
  callback_data | The data to pass to the callback.

Examples
  emotion_test_main.c.

## ECORE_GETOPT_CALLBACK_ARGS

#define ECORE_GETOPT_CALLBACK_ARGS | ( |  | shortname,
|  |  | longname,
|  |  | help,
|  |  | metavar,
|  |  | callback_func,
|  |  | callback_data )

Value:
ECORE_GETOPT_CALLBACK_FULL(shortname, longname, help, metavar, \
callback_func, callback_data, \
ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES, \
NULL)

Definition for filling Ecore_Getopt_Desc table with an callback action.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.
  metavar | The metavar message concerning the parameter of the option.
  callback_func | The callback function to call.
  callback_data | The data to pass to the callback.

Examples
  emotion_test_main.c.

## ECORE_GETOPT_HELP

#define ECORE_GETOPT_HELP | ( |  | shortname,
|  |  | longname )

Value:
{shortname, longname, "show this message.", "CATEGORY", \
ECORE_GETOPT_ACTION_HELP, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_HELP
@ ECORE_GETOPT_ACTION_HELP
Show help text.
Definition Ecore_Getopt.h:73

Definition for filling Ecore_Getopt_Desc table with a help action.

Parameters

  shortname | The help option short name.
  longname | The help option long name.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, ecore_thread_example.c, and emotion_test_main.c.

## ECORE_GETOPT_VERSION

#define ECORE_GETOPT_VERSION | ( |  | shortname,
|  |  | longname )

Value:
{shortname, longname, "show program version.", NULL, \
ECORE_GETOPT_ACTION_VERSION, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_VERSION
@ ECORE_GETOPT_ACTION_VERSION
Show version.
Definition Ecore_Getopt.h:74

Definition for filling Ecore_Getopt_Desc table with a version action.

Parameters

  shortname | The version option short name.
  longname | The version option long name.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, and emotion_test_main.c.

## ECORE_GETOPT_COPYRIGHT

#define ECORE_GETOPT_COPYRIGHT | ( |  | shortname,
|  |  | longname )

Value:
{shortname, longname, "show copyright.", NULL, \
ECORE_GETOPT_ACTION_COPYRIGHT, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_COPYRIGHT
@ ECORE_GETOPT_ACTION_COPYRIGHT
Show copyright.
Definition Ecore_Getopt.h:75

Definition for filling Ecore_Getopt_Desc table with a copyright action.

Parameters

  shortname | The copyright option short name.
  longname | The copyright option long name.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, and emotion_test_main.c.

## ECORE_GETOPT_LICENSE

#define ECORE_GETOPT_LICENSE | ( |  | shortname,
|  |  | longname )

Value:
{shortname, longname, "show license.", NULL, \
ECORE_GETOPT_ACTION_LICENSE, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_LICENSE
@ ECORE_GETOPT_ACTION_LICENSE
Show license.
Definition Ecore_Getopt.h:76

Definition for filling Ecore_Getopt_Desc table with a license action.

Parameters

  shortname | The license option short name.
  longname | The license option long name.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, and emotion_test_main.c.

## ECORE_GETOPT_BREAK

#define ECORE_GETOPT_BREAK | ( |  | shortname,
|  |  | longname )

Value:
{shortname, longname, "stop parsing options.", NULL, \
ECORE_GETOPT_ACTION_BREAK, \
{.dummy = NULL}}
ECORE_GETOPT_ACTION_BREAK
@ ECORE_GETOPT_ACTION_BREAK
Stop parsing options.
Definition Ecore_Getopt.h:77

Definition for filling Ecore_Getopt_Desc table with a break action.

Parameters

  shortname | The option short name.
  longname | The option long name.

## ECORE_GETOPT_BREAK_STR

#define ECORE_GETOPT_BREAK_STR | ( |  | shortname,
|  |  | longname,
|  |  | help )

Value:
{shortname, longname, help, NULL, \
ECORE_GETOPT_ACTION_BREAK, \
{.dummy = NULL}}

Definition for filling Ecore_Getopt_Desc table with a break action with help message.

Parameters

  shortname | The option short name.
  longname | The option long name.
  help | The help message concerning this option.

## ECORE_GETOPT_CATEGORY

#define ECORE_GETOPT_CATEGORY | ( |  | name,
|  |  | help )

Value:
{0, name, help, NULL, ECORE_GETOPT_ACTION_CATEGORY, {.dummy = NULL}}

## ECORE_GETOPT_VALUE_STR

#define ECORE_GETOPT_VALUE_STR | ( |  | val | ) |

Value:
{.strp = &(val)}

Definition for options that store a single value in a variable of type string.

Parameters

  val | The value to store.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, and emotion_test_main.c.

## ECORE_GETOPT_VALUE_BOOL

#define ECORE_GETOPT_VALUE_BOOL | ( |  | val | ) |

Value:
{.boolp = &(val)}

Definition for options that store a single value in a variable of type boolean.

Parameters

  val | The value to store.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, ecore_thread_example.c, and emotion_test_main.c.

## ECORE_GETOPT_VALUE_SHORT

#define ECORE_GETOPT_VALUE_SHORT | ( |  | val | ) |

Value:
{.shortp = &(val)}

Definition for options that store a single value in a variable of type short.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_INT

#define ECORE_GETOPT_VALUE_INT | ( |  | val | ) |

Value:
{.intp = &(val)}

Definition for options that store a single value in a variable of type int.

Parameters

  val | The value to store.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, ecore_thread_example.c, and emotion_test_main.c.

## ECORE_GETOPT_VALUE_LONG

#define ECORE_GETOPT_VALUE_LONG | ( |  | val | ) |

Value:
{.longp = &(val)}

Definition for options that store a single value in a variable of type long.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_USHORT

#define ECORE_GETOPT_VALUE_USHORT | ( |  | val | ) |

Value:
{.ushortp = &(val)}

Definition for options that store a single value in a variable of type unsigned short.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_UINT

#define ECORE_GETOPT_VALUE_UINT | ( |  | val | ) |

Value:
{.uintp = &(val)}

Definition for options that store a single value in a variable of type unsigned int.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_ULONG

#define ECORE_GETOPT_VALUE_ULONG | ( |  | val | ) |

Value:
{.ulongp = &(val)}

Definition for options that store a single value in a variable of type unsigned long.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_DOUBLE

#define ECORE_GETOPT_VALUE_DOUBLE | ( |  | val | ) |

Value:
{.doublep = &(val)}

Definition for options that store a single value in a variable of type double.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_PTR

#define ECORE_GETOPT_VALUE_PTR | ( |  | val | ) |

Value:
{.ptrp = &(val)}

Definition for options that store a single value in a variable of type pointer.

Parameters

  val | The value to store.

## ECORE_GETOPT_VALUE_PTR_CAST

#define ECORE_GETOPT_VALUE_PTR_CAST | ( |  | val | ) |

Value:
{.ptrp = (void **)&(val)}

Definition for options that store a single value in a variable of type pointer casted.

Parameters

  val | The value to store.

Examples
  emotion_test_main.c.

## ECORE_GETOPT_VALUE_LIST

#define ECORE_GETOPT_VALUE_LIST | ( |  | val | ) |

Value:
{.listp = &(val)}

Definition for options that store a single value in a variable of type list.

Parameters

  val | The value to store.

Examples
  ecore_thread_example.c.

## ECORE_GETOPT_VALUE_NONE

#define ECORE_GETOPT_VALUE_NONE {.ptrp = NULL}

Definition for options that store a NULL value.

Parameters

  val | The value to store.

Examples
  ecore_con_client_example.c, ecore_con_server_example.c, ecore_thread_example.c, and emotion_test_main.c.

## Enumeration Type Documentation

## Ecore_Getopt_Action

enum Ecore_Getopt_Action

Enumeration for defining the actions to do when parsing command line parameters.

Enumerator
ECORE_GETOPT_ACTION_STORE | Store a value.
ECORE_GETOPT_ACTION_STORE_CONST | Store a const.
ECORE_GETOPT_ACTION_STORE_TRUE | Store TRUE.
ECORE_GETOPT_ACTION_STORE_FALSE | Store FALSE.
ECORE_GETOPT_ACTION_CHOICE | Store a choice between several values.
ECORE_GETOPT_ACTION_APPEND | Allocate and store a new value of type Ecore_Getopt_Type.
ECORE_GETOPT_ACTION_COUNT | Store a count number.
ECORE_GETOPT_ACTION_CALLBACK | Call a callback.
ECORE_GETOPT_ACTION_HELP | Show help text.
ECORE_GETOPT_ACTION_VERSION | Show version.
ECORE_GETOPT_ACTION_COPYRIGHT | Show copyright.
ECORE_GETOPT_ACTION_LICENSE | Show license.
ECORE_GETOPT_ACTION_BREAK | Stop parsing options.

## Ecore_Getopt_Type

enum Ecore_Getopt_Type

Enumeration for defining the type of the values to store when using append action.

Enumerator
ECORE_GETOPT_TYPE_STR | Value of type string.
ECORE_GETOPT_TYPE_BOOL | Value of type boolean.
ECORE_GETOPT_TYPE_SHORT | Value of type short.
ECORE_GETOPT_TYPE_INT | Value of type int.
ECORE_GETOPT_TYPE_LONG | Value of type long.
ECORE_GETOPT_TYPE_USHORT | Value of type unsigned short.
ECORE_GETOPT_TYPE_UINT | Value of type unsigned int.
ECORE_GETOPT_TYPE_ULONG | Value of type unsigned long.
ECORE_GETOPT_TYPE_DOUBLE | Value of type double.

## Ecore_Getopt_Desc_Arg_Requirement

enum Ecore_Getopt_Desc_Arg_Requirement

Enumeration for defining if the command line options require an argument.

Enumerator
ECORE_GETOPT_DESC_ARG_REQUIREMENT_NO | Argument is not required.
ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES | Argument is required.
ECORE_GETOPT_DESC_ARG_REQUIREMENT_OPTIONAL | Argument is optional.

## Function Documentation

## ecore_getopt_help()

EAPI void ecore_getopt_help | ( | FILE * | fp,
|  | const Ecore_Getopt * | info )

Shows nicely formatted help message for the given parser.

Parameters

  fp | The file the message will be printed on.
  info | The structure containing information about command line options.

See also
  ecore_getopt_help_category()

## ecore_getopt_help_category()

EAPI Eina_Bool ecore_getopt_help_category | ( | FILE * | fp,
|  | const Ecore_Getopt * | info,
|  | const char * | category )

Shows help for a single category (along with program usage and description).

Parameters

  fp | The file the message will be printed on.
  info | The structure containing information about command line options.
  category | The category to print.

Returns
  `EINA_TRUE` when the category exists, `EINA_FALSE` otherwise.

See also
  ecore_getopt_help()

References _Ecore_Getopt_Desc::action, _Ecore_Getopt::descs, EINA_FALSE, EINA_TRUE, and _Ecore_Getopt_Desc::longname.

## ecore_getopt_parser_has_duplicates()

EAPI Eina_Bool ecore_getopt_parser_has_duplicates | ( | const Ecore_Getopt * | parser | ) |

Checks parser for duplicate entries, print them out.

Returns
  `EINA_TRUE` if there are duplicates, `EINA_FALSE` otherwise.

Parameters

  parser | The parser to be checked.

References _Ecore_Getopt::descs, EINA_FALSE, EINA_TRUE, _Ecore_Getopt_Desc::longname, and _Ecore_Getopt_Desc::shortname.

## ecore_getopt_parse()

EAPI int ecore_getopt_parse | ( | const Ecore_Getopt * | parser,
|  | Ecore_Getopt_Value * | values,
|  | int | argc,
|  | char ** | argv )

Parses command line parameters.

Walks the command line parameters and parse them based on parser description, doing actions based on `parser->descs->action`, like showing help text, license, copyright, storing values in values and so on.

It is expected that values is of the same size than `parser->descs`, options that do not need a value it will be left untouched.

All values are expected to be initialized before use. Options with action `ECORE_GETOPT_ACTION_STORE` and non required arguments (others than `ECORE_GETOPT_DESC_ARG_REQUIREMENT_YES`), are expected to provide a value in `def` to be used.

The following actions will store `1` on value as a boolean (`value->boolp`) if it's not `NULL` to indicate these actions were executed:

- `ECORE_GETOPT_ACTION_HELP`
- `ECORE_GETOPT_ACTION_VERSION`
- `ECORE_GETOPT_ACTION_COPYRIGHT`
- `ECORE_GETOPT_ACTION_LICENSE`

Just `ECORE_GETOPT_ACTION_APPEND` will allocate memory and thus need to be freed. For consistency between all of appended subtypes, `eina_list->data` will contain an allocated memory with the value, that is, for `ECORE_GETOPT_TYPE_STR` it will contain a copy of the argument, `ECORE_GETOPT_TYPE_INT` a pointer to an allocated integer and so on.

If parser is in strict mode (see `Ecore_Getopt->strict`), then any error will abort parsing and `-1` is returned. Otherwise it will try to continue as far as possible.

This function may reorder argv elements.

Translation of help strings (description), metavar, usage, license and copyright may be translated, standard/global gettext() call will be applied on them if ecore was compiled with such support.

This function will not parse positional arguments! If these are declared (metavar is defined with both shortname and longname being empty), then you must call ecore_getopt_parse_positional() with the last argument (`start`) being the result of this function. This is done so you can have "quit options", those that once called you want to exit without doing further parsing, as is the case with help, license, copyright, version and eventually others you may define.

Parameters

  parser | Description of how to work.
  values | Where to store values, it is assumed that this is a vector of the same size as `parser->descs`. Values should be previously initialized.
  argc | How many elements in argv. If not provided it will be retrieved with ecore_app_args_get().
  argv | Command line parameters.

Returns
  Index of first non-option parameter or `-1` on error.

See also
  ecore_getopt_parse_positional()

References ecore_app_args_get(), _Ecore_Getopt_Desc::longname, _Ecore_Getopt::prog, and _Ecore_Getopt_Desc::shortname.

## ecore_getopt_parse_positional()

EAPI int ecore_getopt_parse_positional | ( | const Ecore_Getopt * | parser,
|  | Ecore_Getopt_Value * | values,
|  | int | argc,
|  | char ** | argv,
|  | int | start )

Parses command line positional parameters.

Walks the command line positional parameters (those that do not start with "-" or "--") and parse them based on parser description, doing actions based on `parser->descs->action`, like storing values of some type.

It is expected that values is of the same size than `parser->descs`, same as with ecore_getopt_parse().

All values are expected to be initialized before use.

Unlike the ecore_getopt_parse(), only the following options are supported:

- `ECORE_GETOPT_ACTION_STORE`
- `ECORE_GETOPT_ACTION_CHOICE`
- `ECORE_GETOPT_ACTION_APPEND`
- `ECORE_GETOPT_ACTION_CALLBACK`

There is a special case for `ECORE_GETOPT_ACTION_APPEND` as it will consume all remaining elements. It is also special in the sense that it will allocate memory and thus need to be freed. For consistency between all of appended subtypes, `eina_list->data` will contain an allocated memory with the value, that is, for `ECORE_GETOPT_TYPE_STR` it will contain a copy of the argument, `ECORE_GETOPT_TYPE_INT` a pointer to an allocated integer and so on.

If parser is in strict mode (see `Ecore_Getopt->strict`), then any error will abort parsing and `-1` is returned. Otherwise it will try to continue as far as possible.

Translation of help strings (description) and metavar may be done, standard/global gettext() call will be applied on them if ecore was compiled with such support.

Parameters

  parser | Description of how to work.
  values | Where to store values, it is assumed that this is a vector of the same size as `parser->descs`. Values should be previously initialized.
  argc | How many elements in argv. If not provided it will be retrieved with ecore_app_args_get().
  argv | Command line parameters.
  start | The initial position argument to look at, usually the return of ecore_getopt_parse(). If less than 1, will try to find it automatically.

Returns
  Index of first non-option parameter or `-1` on error. If the last positional argument is of action `ECORE_GETOPT_ACTION_APPEND` then it will be the same as argc.

References _Ecore_Getopt::descs, ecore_app_args_get(), _Ecore_Getopt_Desc::longname, _Ecore_Getopt_Desc::metavar, _Ecore_Getopt::prog, and _Ecore_Getopt_Desc::shortname.

## ecore_getopt_list_free()

EAPI Eina_List * ecore_getopt_list_free | ( | Eina_List * | list | ) |

Utilities to free list and nodes allocated by ECORE_GETOPT_ACTION_APPEND.

Parameters

  list | Pointer to list to be freed.

Returns
  always `NULL`, so you can easily make your list head `NULL`.

References EINA_LIST_FREE.

## ecore_getopt_callback_geometry_parse()

EAPI Eina_Bool ecore_getopt_callback_geometry_parse | ( | const Ecore_Getopt * | parser,
|  | const Ecore_Getopt_Desc * | desc,
|  | const char * | str,
|  | void * | data,
|  | Ecore_Getopt_Value * | storage )

Helper ecore_getopt callback to parse geometry (x:y:w:h).

Parameters

  parser | This parameter isn't in use.
  desc | This parameter isn't in use.
  str | Geometry value
  data | This parameter isn't in use.
  storage | Must be a pointer to `Eina_Rectangle` and will be used to store the four values passed in the given string.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on incorrect geometry value.

This is a helper function to be used with ECORE_GETOPT_CALLBACK_*().

`callback_data` value is ignored, you can safely use `NULL`.

References EINA_FALSE, EINA_TRUE, EINA_UNUSED, and _Ecore_Getopt_Value::ptrp.

## ecore_getopt_callback_size_parse()

EAPI Eina_Bool ecore_getopt_callback_size_parse | ( | const Ecore_Getopt * | parser,
|  | const Ecore_Getopt_Desc * | desc,
|  | const char * | str,
|  | void * | data,
|  | Ecore_Getopt_Value * | storage )

Helper ecore_getopt callback to parse geometry size (WxH).

Parameters

  parser | This parameter isn't in use.
  desc | This parameter isn't in use.
  str | size value
  data | This parameter isn't in use.
  storage | Must be a pointer to `Eina_Rectangle` and will be used to store the two values passed in the given string and `0` in the x and y fields.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on incorrect size value.

`callback_data` value is ignored, you can safely use `NULL`.

References EINA_FALSE, EINA_TRUE, EINA_UNUSED, and _Ecore_Getopt_Value::ptrp.